dnl Arrange for everything to disappear initially.
divert(-1)
include(acgeneral.m4)
builtin(include, acspecific.m4)
builtin(include, acoldnames.m4)
define(AC_DIVERSION_NOTICE, -1)
define(AC_DIVERSION_INIT, -1)
define(AC_DIVERSION_SED, -1)
define(AC_DIVERSION_NORMAL_4, -1)
define(AC_DIVERSION_NORMAL_3, -1)
define(AC_DIVERSION_NORMAL_2, -1)
define(AC_DIVERSION_NORMAL_1, -1)
define(AC_DIVERSION_NORMAL, -1)

define(AC_DIVERSION_CURRENT, -1)

define(AC_DIVERSION_SYSTEM_H, 9)
define(AC_DIVERSION_ALLOCA, 10)
define(AC_DIVERSION_HEADERS, 11)

dnl Now define alternate versions of some macros.  Bogus, but we can't
dnl do it any other way, since M4 doesn't let us divert to a file.

dnl Require a particular system header.
define([AC_REQUIRE_HEADER], [
ifdef([$1], ,
[define([$1],Zardoz!)
AC_DIVERT_PUSH(AC_DIVERSION_HEADERS)dnl
#include <$1>
AC_DIVERT_POP()])])

define([AC_FUNC_ALLOCA], [
AC_PROVIDE([AC_FUNC_ALLOCA])
AC_DIVERT_PUSH(AC_DIVERSION_ALLOCA)dnl
/* AIX requires this to be the first thing in the file.  */
#ifdef __GNUC__
# define alloca __builtin_alloca
#else
# if HAVE_ALLOCA_H
#  include <alloca.h>
# else
#  ifdef _AIX
#pragma alloca
#  else
#   ifndef alloca /* predefined by HP cc +Olibcalls */
char *alloca ();
#   endif
#  endif
# endif
#endif
AC_DIVERT_POP()])

dnl FIXME do something for AC_FUNC_SETVBUF_REVERSED?

define([AC_HEADER_DIRENT], [
AC_PROVIDE([AC_HEADER_DIRENT])
AC_DIVERT_PUSH(AC_DIVERSION_SYSTEM_H)dnl
/* Declare directory reading routines and structures.  */
#ifdef __MSDOS__
# include "msd_dir.h"
# define NAMLEN(dirent) ((dirent)->d_namlen)
#else
# ifdef HAVE_DIRENT_H
#  include <dirent.h>
#  define NAMLEN(dirent) (strlen((dirent)->d_name))
# else
#  define dirent direct
#  define NAMLEN(dirent) ((dirent)->d_namlen)
#  ifdef HAVE_SYS_NDIR_H
#   include <sys/ndir.h>
#  endif
#  ifdef HAVE_SYS_DIR_H
#   include <sys/dir.h>
#  endif
#  ifdef HAVE_NDIR_H
#   include <ndir.h>
#  endif
# endif
#endif
AC_DIVERT_POP()])

define([AC_HEADER_MAJOR], [
AC_PROVIDE([AC_HEADER_MAJOR])
AC_DIVERT_PUSH(AC_DIVERSION_SYSTEM_H)dnl
AC_REQUIRE_HEADER([sys/types.h])
/* Since major is a function on SVR4, we can't use `ifndef major'.  */
#ifdef MAJOR_IN_MKDEV
# include <sys/mkdev.h>
# define HAVE_MAJOR
#endif

#ifdef MAJOR_IN_SYSMACROS
# include <sys/sysmacros.h>
# define HAVE_MAJOR
#endif

#ifdef major			/* Might be defined in sys/types.h.  */
# define HAVE_MAJOR
#endif

#ifndef HAVE_MAJOR
# define major(dev) (((dev) >> 8) & 0xff)
# define minor(dev) ((dev) & 0xff)
# define makedev(ma, mi) (((ma) << 8) | (mi))
#endif
#undef HAVE_MAJOR
AC_DIVERT_POP()])

dnl FIXME this is bogus
define([AC_HEADER_STDC], [
AC_PROVIDE([AC_HEADER_STDC])
AC_DIVERT_PUSH(AC_DIVERSION_SYSTEM_H)dnl
#if STDC_HEADERS
# include <string.h>
#else
# ifndef HAVE_STRCHR
#  define strchr index
#  define strrchr rindex
# endif
char *strchr (), *strrchr ();
# ifndef HAVE_MEMCPY
#  define memcpy(d, s, n) bcopy ((s), (d), (n))
#  define memmove(d, s, n) bcopy ((s), (d), (n))
# endif
#endif
AC_DIVERT_POP()])

define([AC_HEADER_SYS_WAIT], [
AC_PROVIDE([AC_HEADER_SYS_WAIT])
AC_DIVERT_PUSH(AC_DIVERSION_SYSTEM_H)dnl
AC_REQUIRE_HEADER([sys/types.h])
#if HAVE_SYS_WAIT_H
# include <sys/wait.h>
#endif
#ifndef WEXITSTATUS
# define WEXITSTATUS(stat_val) ((unsigned)(stat_val) >> 8)
#endif
#ifndef WIFEXITED
# define WIFEXITED(stat_val) (((stat_val) & 255) == 0)
#endif
AC_DIVERT_POP()])

define([AC_HEADER_TIME], [
AC_PROVIDE([AC_HEADER_TIME])
AC_DIVERT_PUSH(AC_DIVERSION_SYSTEM_H)dnl
#if TIME_WITH_SYS_TIME
# include <sys/time.h>
# include <time.h>
#else
# if HAVE_SYS_TIME_H
#  include <sys/time.h>
# else
#  include <time.h>
# endif
#endif
AC_DIVERT_POP()])

define([AC_HEADER_STAT], [
AC_PROVIDE([AC_HEADER_STAT])
AC_DIVERT_PUSH([AC_DIVERSION_SYSTEM_H])dnl
AC_REQUIRE_HEADER([sys/types.h])
AC_REQUIRE_HEADER([sys/stat.h])
#if !S_IRUSR
# if S_IREAD
#  define S_IRUSR S_IREAD
# else
#  define S_IRUSR 00400
# endif
#endif

#if !S_IWUSR
# if S_IWRITE
#  define S_IWUSR S_IWRITE
# else
#  define S_IWUSR 00200
# endif
#endif

#if !S_IXUSR
# if S_IEXEC
#  define S_IXUSR S_IEXEC
# else
#  define S_IXUSR 00100
# endif
#endif

#ifdef STAT_MACROS_BROKEN
# undef S_ISBLK
# undef S_ISCHR
# undef S_ISDIR
# undef S_ISFIFO
# undef S_ISLNK
# undef S_ISMPB
# undef S_ISMPC
# undef S_ISNWK
# undef S_ISREG
# undef S_ISSOCK
#endif

#if !defined(S_ISBLK) && defined(S_IFBLK)
# define S_ISBLK(m) (((m) & S_IFMT) == S_IFBLK)
#endif
#if !defined(S_ISCHR) && defined(S_IFCHR)
# define S_ISCHR(m) (((m) & S_IFMT) == S_IFCHR)
#endif
#if !defined(S_ISDIR) && defined(S_IFDIR)
# define S_ISDIR(m) (((m) & S_IFMT) == S_IFDIR)
#endif
#if !defined(S_ISREG) && defined(S_IFREG)
# define S_ISREG(m) (((m) & S_IFMT) == S_IFREG)
#endif
#if !defined(S_ISFIFO) && defined(S_IFIFO)
# define S_ISFIFO(m) (((m) & S_IFMT) == S_IFIFO)
#endif
#if !defined(S_ISLNK) && defined(S_IFLNK)
# define S_ISLNK(m) (((m) & S_IFMT) == S_IFLNK)
#endif
#if !defined(S_ISSOCK) && defined(S_IFSOCK)
# define S_ISSOCK(m) (((m) & S_IFMT) == S_IFSOCK)
#endif
#if !defined(S_ISMPB) && defined(S_IFMPB) /* V7 */
# define S_ISMPB(m) (((m) & S_IFMT) == S_IFMPB)
# define S_ISMPC(m) (((m) & S_IFMT) == S_IFMPC)
#endif
#if !defined(S_ISNWK) && defined(S_IFNWK) /* HP/UX */
# define S_ISNWK(m) (((m) & S_IFMT) == S_IFNWK)
#endif
AC_DIVERT_POP()])

dnl Arrange for our stuff to be output, but nothing else.
define([AC_OUTPUT], [
divert[]dnl
# WARNING: This file is automatically generated, do not modify it!
# Common declarations being dependent on system configuration.
# Copyright (C) 1996 Free Software Foundation, Inc.

#ifdef HAVE_CONFIG_H
# include <config.h>
#endif

dnl Do alloca first, for AIX.
undivert(AC_DIVERSION_ALLOCA)dnl
undivert(AC_DIVERSION_HEADERS)dnl
undivert(AC_DIVERSION_SYSTEM_H)dnl
divert(-1)
undivert])

define([AC_SYSTEM_HEADER], [
define([AC_SYSTEM_H], patsubst($1, [ .*$], []))dnl
/* AC_SYSTEM_H automatically generated by autosystem.  */
])

dnl Completely bogus.
define([AC_INIT_BINSH], [])

dnl
dnl Stuff for AC_FEATUREs
dnl

define([AC_FEATURE_CTYPE],[
AC_PROVIDE([AC_FEATURE_CTYPE])
AC_DIVERT_PUSH(AC_DIVERSION_SYSTEM_H)dnl
AC_REQUIRE_HEADER([ctype.h])
#if defined (STDC_HEADERS) || (!defined (isascii) && !defined (HAVE_ISASCII))
# define ISASCII(c) 1
#else
# define ISASCII(c) isascii(c)
#endif

#ifdef isblank
# define ISBLANK(c) (ISASCII (c) && isblank (c))
#else
# define ISBLANK(c) ((c) == ' ' || (c) == '\t')
#endif
#ifdef isgraph
# define ISGRAPH(c) (ISASCII (c) && isgraph (c))
#else
# define ISGRAPH(c) (ISASCII (c) && isprint (c) && !isspace (c))
#endif

#define ISPRINT(c) (ISASCII (c) && isprint (c))
#define ISDIGIT(c) (ISASCII (c) && isdigit (c))
#define ISALNUM(c) (ISASCII (c) && isalnum (c))
#define ISALPHA(c) (ISASCII (c) && isalpha (c))
#define ISCNTRL(c) (ISASCII (c) && iscntrl (c))
#define ISLOWER(c) (ISASCII (c) && islower (c))
#define ISPUNCT(c) (ISASCII (c) && ispunct (c))
#define ISSPACE(c) (ISASCII (c) && isspace (c))
#define ISUPPER(c) (ISASCII (c) && isupper (c))
#define ISXDIGIT(c) (ISASCII (c) && isxdigit (c))
AC_DIVERT_POP()])

define([AC_FEATURE_ERRNO],[
AC_PROVIDE([AC_FEATURE_ERRNO])
AC_DIVERT_PUSH(AC_DIVERSION_SYSTEM_H)dnl
AC_REQUIRE_HEADER([errno.h])
#ifndef errno
extern int errno;
#endif
AC_DIVERT_POP()])

define([AC_FEATURE_EXIT],[
AC_PROVIDE([AC_FEATURE_EXIT])
AC_REQUIRE_HEADER([stdlib.h])
AC_DIVERT_PUSH(AC_DIVERSION_SYSTEM_H)dnl
# From kpathsea
/* SunOS 4.1.1 gets STDC_HEADERS defined, but it doesn't provide
   EXIT_FAILURE.  So far no system has defined one of EXIT_FAILURE and
   EXIT_SUCCESS without the other.  */
#ifndef EXIT_SUCCESS
# ifdef VMS
#  define EXIT_SUCCESS 1
#  define EXIT_FAILURE 0
# else
#  define EXIT_SUCCESS 0
#  define EXIT_FAILURE 1
# endif
#endif
AC_DIVERT_POP()])
